unit StrTransformErr;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

function StrToIntErr(const Str : AnsiString; Standard : integer) : integer;
function StrToStrErr(const Str : AnsiString; const Standard : AnsiString) : AnsiString;
function StrToBGRAErr(const Str : AnsiString; Standard : Cardinal) : Cardinal;
function StrToBoolErr(const Str : AnsiString; Standard : Boolean) : Boolean;
function StrToFloatErr(const Str : AnsiString; Standard : Extended) : Extended;

implementation

function StrToFloatErr(const Str : AnsiString; Standard : Extended) : Extended;
var
 i  : integer;
 b1 : Boolean;
 b2 : Boolean;
begin
 Result := Standard;
 b1 := false;
 b2 := false;
 if (Str = '') then exit;
 for i := 1 to Length(Str) do begin
  if (Str[i] = '-') then if ((i > 1) and (Str[i-1] <> 'e') and (Str[i-1] <> 'E')) or (i = Length(Str)) then exit;
  if (Str[i] = 'e') or (Str[i] = 'E') then if (b1) or (i = Length(Str)) then exit else b1 := true;
  if (Str[i] = ',') then if (b2) or (i = Length(Str)) then exit else b2 := true;
  if (Str[i] <> '0') and
   (Str[i] <> '1') and
   (Str[i] <> '2') and
   (Str[i] <> '3') and
   (Str[i] <> '4') and
   (Str[i] <> '5') and
   (Str[i] <> '6') and
   (Str[i] <> '7') and
   (Str[i] <> '8') and
   (Str[i] <> '9') and
   (Str[i] <> ',') and
   (Str[i] <> 'e') and
   (Str[i] <> 'E') and
   (Str[i] <> '-') then exit;
 end;
 Result := StrToFloat(Str);
end;

function StrToIntErr(const Str : AnsiString; Standard : integer) : integer;
var i : integer;
begin
 Result := Standard;
 if (Str = '') or (Str = '-') or (Length(Str) > 11) then exit;
 for i := 1 to Length(Str) do begin
  if (i <> 1) and (Str[i] = '-') then exit;
  if (Str[i] <> '0') and
   (Str[i] <> '1') and
   (Str[i] <> '2') and
   (Str[i] <> '3') and
   (Str[i] <> '4') and
   (Str[i] <> '5') and
   (Str[i] <> '6') and
   (Str[i] <> '7') and
   (Str[i] <> '8') and
   (Str[i] <> '9') and
   (Str[i] <> '-') then exit;
 end;
 Result := StrToInt(Str);
end;

function StrToBoolErr(const Str : AnsiString; Standard : Boolean) : Boolean;
begin
 if (LowerCase(Str) = 'true') then Result := true
 else if (LowerCase(Str) = 'false') then Result := false
 else if (LowerCase(Str) = 'yes') then Result := true
 else if (LowerCase(Str) = 'no') then Result := false
 else Result := Standard;
end;

function StrToStrErr(const Str : AnsiString; const Standard : AnsiString) : AnsiString;
begin
 if (Str = '') then Result := Standard
 else Result := Str;
end;

function StrToBGRAErr(const Str : AnsiString; Standard : Cardinal) : Cardinal;
var
 b   : Byte;
 Err : Boolean;
function CharToByte(C : Char) : Byte;
begin
 Result := 0;
 case (C) of
  '0' : Result := 0;
  '1' : Result := 1;
  '2' : Result := 2;
  '3' : Result := 3;
  '4' : Result := 4;
  '5' : Result := 5;
  '6' : Result := 6;
  '7' : Result := 7;
  '8' : Result := 8;
  '9' : Result := 9;
  'a' : Result := 10;
  'b' : Result := 11;
  'c' : Result := 12;
  'd' : Result := 13;
  'e' : Result := 14;
  'f' : Result := 15;
  'A' : Result := 10;
  'B' : Result := 11;
  'C' : Result := 12;
  'D' : Result := 13;
  'E' : Result := 14;
  'F' : Result := 15;
  else Err := true;
 end;
end;
begin
 Err := false;
 Result := 0;
 if (Length(Str) <> 8) and (Length(Str) <> 6) then begin Result := Standard; exit; end;
 b := CharToByte(Str[6]) + CharToByte(Str[5]) * 16;
 PByte(@Result + 0)^ := b;
 b := CharToByte(Str[4]) + CharToByte(Str[3]) * 16;
 PByte(@Result + 1)^ := b;
 b := CharToByte(Str[2]) + CharToByte(Str[1]) * 16;
 PByte(@Result + 2)^ := b;
 if (Length(Str) = 8) then begin
  b := CharToByte(Str[8]) + CharToByte(Str[7]) * 16;
  PByte(@Result + 3)^ := b;
 end;
 if (Err) then Result := Standard;
end;

end.

